<template>
  <div class="homepage">
    <h1 class="hidden">{{ metaseo.title }}</h1>
    <div class="fs-aslide mb56">
      <Slider :banners="banners" />
      <HomeArticles :articles="articles" />
    </div>
    <client-only>
      <ProductReview v-if="seenProducts.length > 0" :products="seenProducts" />
    </client-only>
    <ProductSlider
      v-if="newArrivalProducts.length > 0"
      :id="'moive'"
      title="Hàng mới về"
      :class-name="'product-slide__moive'"
      :products="newArrivalProducts"
      :color-status="'bg-green'"
      :notifi-button="'new'"
    />
    <div
      v-observe-visibility="{
        callback: visibilityChanged,
        once: true,
        throttle,
        intersection: {
          threshold,
        },
      }"
      class="loadmorepage"
    ></div>
    <ProductSlider
      v-if="isShowOnSale"
      :id="'giamgia'"
      title="Giảm giá sốc"
      :class-name="'product-slide__giamgia'"
      :products="onSaleProducts"
      :color-status="'bg-red'"
    />
    <ProductLaptop v-if="isShowLaptop" :laptop="laptopData" />
    <ProductSlider
      v-if="isShowIncoming"
      :id="'dangve'"
      title="Hàng đang về"
      :class-name="'product-slide__dangve'"
      :products="incomingProducts"
      :color-status="'bg-oranger'"
      :notifi-button="'comming'"
    />
    <ProductPC v-if="isShowPC" :pc="pcData" />
    <ProductPhukien v-if="isShowGear" :gear="gearData" />
  </div>
</template>

<script>
export default {
  name: 'Home',
  components: {
    Slider: () => import('~/components/Products/Slider'),
    HomeArticles: () => import('~/components/Articles/HomeArticles'),
    ProductSlider: () => import('~/components/Products/ProductSlider'),
    ProductLaptop: () => import('~/components/Products/ProductLaptop'),
    ProductPhukien: () => import('~/components/Products/ProductPhukien'),
    ProductPC: () => import('~/components/Products/ProductPC'),
    ProductReview: () => import('~/components/Products/ProductReview'),
  },
  async asyncData({ params, $axios }) {
    const banners = await $axios.$get('/home/banners')
    const article = await $axios.$get('/home/articles')
    const metaseo = await $axios.$get('/home/seo')
    const newArrivalProducts = await $axios.$get('/home/products/new_arrival')
    let seenProducts = { data: [] }
    try {
      seenProducts = await $axios.$get('/home/products/seen_list')
    } catch (e) {
      seenProducts = { data: [] }
    }
    return {
      banners: banners.data,
      articles: article.data,
      metaseo: metaseo.data,
      newArrivalProducts: newArrivalProducts.data,
      seenProducts: seenProducts.data,
    }
  },
  data() {
    return {
      incomingProducts: [],
      onSaleProducts: [],
      laptopData: [],
      pcData: [],
      gearData: [],
      seenProducts: [],
      isLoading: true,
      isShowOnSale: false,
      isShowLaptop: false,
      isShowIncoming: false,
      isShowPC: false,
      isShowGear: false,
      throttle: 0,
      threshold: 0,
    }
  },
  mounted() {
    document.querySelector('main').classList.add('page-home')
  },
  destroyed() {
    document.querySelector('main').classList.remove('page-home')
  },
  methods: {
    visibilityChanged(isVisible, entry) {
      const promise1 = this.$axios.$get('/home/products/on_sale')
      const promise2 = this.$axios.$get('/home/products/laptop')
      const promise3 = this.$axios.$get('/home/products/incoming')
      const promise4 = this.$axios.$get('/home/products/pc')
      const promise5 = this.$axios.$get('/home/products/gear')
      Promise.all([promise1, promise2, promise3, promise4, promise5]).then(
        (values) => {
          this.onSaleProducts = values[0].data
          this.laptopData = values[1]
          this.incomingProducts = values[2].data
          this.pcData = values[3]
          this.gearData = values[4]
          this.isShowOnSale = isVisible
          this.isShowLaptop = isVisible
          this.isShowIncoming = isVisible
          this.isShowPC = isVisible
          this.isShowGear = isVisible
        }
      )
      // this.$axios.$get('/home/products/on_sale').then((res1) => {
      //   this.onSaleProducts = res1.data
      //   this.isShowOnSale = isVisible
      // })
      // this.$axios.$get('/home/products/laptop').then((res) => {
      //   this.laptopData = res
      //   this.isShowLaptop = isVisible
      // })
      // this.$axios.$get('/home/products/incoming').then((res) => {
      //   this.incomingProducts = res.data
      //   this.isShowIncoming = isVisible
      // })
      // this.$axios.$get('/home/products/pc').then((res) => {
      //   this.pcData = res
      //   this.isShowPC = isVisible
      // })
      // this.$axios.$get('/home/products/gear').then((res) => {
      //   this.gearData = res
      //   this.isShowGear = isVisible
      // })
    },
  },
  head() {
    return {
      title: this.metaseo.title,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: this.metaseo.description,
        },
        { name: 'keywords', content: this.metaseo.keywords.slice() },
        { name: 'og:title', content: this.metaseo.title },
        { name: 'og:description', content: this.metaseo.description },
      ],
    }
  },
}
</script>
